Index: sansmodels/src/sans/models/c_models/corefourshell.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/corefourshell.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/corefourshell.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -0,0 +1,239 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+	#include "corefourshell.h"
+}
+
+CoreFourShellModel :: CoreFourShellModel() {
+	scale      = Parameter(1.0);
+	rad_core     = Parameter(60.0, true);
+	rad_core.set_min(0.0);
+	sld_core   = Parameter(6.4e-6);
+	thick_shell1     = Parameter(10.0, true);
+	thick_shell1.set_min(0.0);
+	sld_shell1   = Parameter(1.0e-6);
+	thick_shell2     = Parameter(10.0, true);
+	thick_shell2.set_min(0.0);
+	sld_shell2   = Parameter(2.0e-6);
+	thick_shell3     = Parameter(10.0, true);
+	thick_shell3.set_min(0.0);
+	sld_shell3   = Parameter(3.0e-6);
+	thick_shell4     = Parameter(10.0, true);
+	thick_shell4.set_min(0.0);
+	sld_shell4   = Parameter(4.0e-6);
+	sld_solv   = Parameter(6.4e-6);
+	background = Parameter(0.001);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double CoreFourShellModel :: operator()(double q) {
+	double dp[13];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = rad_core();
+	dp[2] = sld_core();
+	dp[3] = thick_shell1();
+	dp[4] = sld_shell1();
+	dp[5] = thick_shell2();
+	dp[6] = sld_shell2();
+	dp[7] = thick_shell3();
+	dp[8] = sld_shell3();
+	dp[9] = thick_shell4();
+	dp[10] = sld_shell4();
+	dp[11] = sld_solv();
+	dp[12] = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	rad_core.get_weights(weights_rad);
+
+	// Get the dispersion points for the thick 1
+	vector<WeightPoint> weights_s1;
+	thick_shell1.get_weights(weights_s1);
+
+	// Get the dispersion points for the thick 2
+	vector<WeightPoint> weights_s2;
+	thick_shell2.get_weights(weights_s2);
+
+	// Get the dispersion points for the thick 3
+	vector<WeightPoint> weights_s3;
+	thick_shell3.get_weights(weights_s3);
+
+	// Get the dispersion points for the thick 4
+	vector<WeightPoint> weights_s4;
+	thick_shell4.get_weights(weights_s4);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double vol = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+		// Loop over radius weight points
+		for(int j=0; j<weights_s1.size(); j++) {
+			dp[3] = weights_s1[j].value;
+			// Loop over radius weight points
+			for(int k=0; k<weights_s2.size(); k++) {
+				dp[5] = weights_s2[k].value;
+				// Loop over radius weight points
+				for(int l=0; l<weights_s3.size(); l++) {
+					dp[7] = weights_s3[l].value;
+					// Loop over radius weight points
+					for(int m=0; m<weights_s4.size(); m++) {
+						dp[9] = weights_s4[m].value;
+						//Un-normalize FourShell by volume
+						sum += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight
+							* FourShell(dp, q) * pow((weights_rad[i].value+weights_s1[j].value+weights_s2[k].value+weights_s3[l].value+weights_s4[m].value),3);
+						//Find average volume
+						vol += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight
+							* pow((weights_rad[i].value+weights_s1[j].value+weights_s2[k].value+weights_s3[l].value+weights_s4[m].value),3);
+
+						norm += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight;
+					}
+				}
+			}
+		}
+	}
+
+	if (vol != 0.0 && norm != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm);}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double CoreFourShellModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the sphere
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double CoreFourShellModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double CoreFourShellModel :: calculate_ER() {
+	CoreFourShellParameters dp;
+
+	dp.scale = scale();
+	dp.rad_core = rad_core();
+	dp.sld_core = sld_core();
+	dp.thick_shell1 = thick_shell1();
+	dp.sld_shell1 = sld_shell1();
+	dp.thick_shell2 = thick_shell2();
+	dp.sld_shell2 = sld_shell2();
+	dp.thick_shell3 = thick_shell3();
+	dp.sld_shell3 = sld_shell3();
+	dp.thick_shell4 = thick_shell4();
+	dp.sld_shell4 = sld_shell4();
+	dp.sld_solv = sld_solv();
+	dp.background = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	rad_core.get_weights(weights_rad);
+
+	// Get the dispersion points for the thick 1
+	vector<WeightPoint> weights_s1;
+	thick_shell1.get_weights(weights_s1);
+
+	// Get the dispersion points for the thick 2
+	vector<WeightPoint> weights_s2;
+	thick_shell2.get_weights(weights_s2);
+
+	// Get the dispersion points for the thick 3
+	vector<WeightPoint> weights_s3;
+	thick_shell3.get_weights(weights_s3);
+
+	// Get the dispersion points for the thick 4
+	vector<WeightPoint> weights_s4;
+	thick_shell4.get_weights(weights_s4);
+
+	double rad_out = 0.0;
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp.rad_core = weights_rad[i].value;
+		// Loop over radius weight points
+		for(int j=0; j<weights_s1.size(); j++) {
+			dp.thick_shell1 = weights_s1[j].value;
+			// Loop over radius weight points
+			for(int k=0; k<weights_s2.size(); k++) {
+				dp.thick_shell2 = weights_s2[k].value;
+				// Loop over radius weight points
+				for(int l=0; l<weights_s3.size(); l++) {
+					dp.thick_shell3 = weights_s3[l].value;
+					// Loop over radius weight points
+					for(int m=0; m<weights_s4.size(); m++) {
+						dp.thick_shell4 = weights_s4[m].value;
+						//Un-normalize FourShell by volume
+						sum += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight
+							* (dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4);
+						norm += weights_rad[i].weight*weights_s1[j].weight*weights_s2[k].weight*weights_s3[l].weight*weights_s4[m].weight;
+					}
+				}
+			}
+		}
+	}
+	if (norm != 0){
+		//return the averaged value
+		rad_out =  sum/norm;}
+	else{
+		//return normal value
+		rad_out = dp.rad_core+dp.thick_shell1+dp.thick_shell2+dp.thick_shell3+dp.thick_shell4;}
+
+	return rad_out;
+}
Index: sansmodels/src/sans/models/c_models/flexcyl_ellipX.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/flexcyl_ellipX.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/flexcyl_ellipX.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -0,0 +1,203 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "libStructureFactor.h"
+	#include "flexcyl_ellipX.h"
+}
+
+FlexCylEllipXModel :: FlexCylEllipXModel() {
+	scale      = Parameter(1.0);
+	length     = Parameter(1000.0, true);
+	length.set_min(0.0);
+	kuhn_length = Parameter(100.0, true);
+	kuhn_length.set_min(0.0);
+	radius  = Parameter(20.0, true);
+	radius.set_min(0.0);
+	axis_ratio = Parameter(1.5);
+	axis_ratio.set_min(0.0);
+	sldCyl   = Parameter(1.0e-6);
+	sldSolv   = Parameter(6.3e-6);
+	background = Parameter(0.0001);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double FlexCylEllipXModel :: operator()(double q) {
+	double dp[8];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = length();
+	dp[2] = kuhn_length();
+	dp[3] = radius();
+	dp[4] = axis_ratio();
+	dp[5] = sldCyl();
+	dp[6] = sldSolv();
+	dp[7] = 0.0;
+
+	// Get the dispersion points for the length
+	vector<WeightPoint> weights_len;
+	length.get_weights(weights_len);
+
+	// Get the dispersion points for the kuhn_length
+	vector<WeightPoint> weights_kuhn;
+	kuhn_length.get_weights(weights_kuhn);
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Get the dispersion points for the axis_ratio
+	vector<WeightPoint> weights_ratio;
+	axis_ratio.get_weights(weights_ratio);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double vol = 0.0;
+
+	// Loop over length weight points
+	for(int i=0; i< (int)weights_len.size(); i++) {
+		dp[1] = weights_len[i].value;
+
+		// Loop over kuhn_length weight points
+		for(int j=0; j< (int)weights_kuhn.size(); j++) {
+			dp[2] = weights_kuhn[j].value;
+
+			// Loop over radius weight points
+			for(int k=0; k< (int)weights_rad.size(); k++) {
+				dp[3] = weights_rad[k].value;
+				// Loop over axis_ratio weight points
+				for(int l=0; l< (int)weights_ratio.size(); l++) {
+					dp[4] = weights_ratio[l].value;
+
+					//Un-normalize by volume
+					sum += weights_len[i].weight * weights_kuhn[j].weight*weights_rad[k].weight
+						* weights_ratio[l].weight * FlexCyl_Ellip(dp, q)
+						* (pow(weights_rad[k].value,2.0) * weights_ratio[l].value * weights_len[i].value);
+					//Find weighted volume
+					vol += weights_rad[k].weight * weights_kuhn[j].weight
+						* weights_len[i].weight * weights_ratio[l].weight
+						*pow(weights_rad[k].value,2.0)* weights_ratio[l].weight*weights_len[i].value;
+					norm += weights_len[i].weight * weights_kuhn[j].weight
+						*weights_rad[k].weight* weights_ratio[l].weight;
+				}
+			}
+		}
+	}
+	if (vol != 0.0 && norm != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm);}
+
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double FlexCylEllipXModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the triaxial ellipsoid
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double FlexCylEllipXModel :: evaluate_rphi(double q, double phi) {
+	//double qx = q*cos(phi);
+	//double qy = q*sin(phi);
+	return (*this).operator()(q);
+}
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double FlexCylEllipXModel :: calculate_ER() {
+	FlexCyl_EllipXParameters dp;
+
+	dp.radius  = radius();
+	dp.length     = length();
+	dp.axis_ratio  = axis_ratio();
+
+	double rad_out = 0.0;
+	double suf_rad = sqrt(dp.radius*dp.radius*dp.axis_ratio );
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Get the dispersion points for the total length
+	vector<WeightPoint> weights_length;
+	length.get_weights(weights_length);
+
+	// Get the dispersion points for minor radius
+	vector<WeightPoint> weights_radius ;
+	radius.get_weights(weights_radius);
+
+	// Get the dispersion points for axis ratio = major_radius/minor_radius
+	vector<WeightPoint> weights_ratio ;
+	axis_ratio.get_weights(weights_ratio);
+
+	// Loop over major shell weight points
+	for(int i=0; i< (int)weights_length.size(); i++) {
+		dp.length = weights_length[i].value;
+		for(int k=0; k< (int)weights_radius.size(); k++) {
+			dp.radius = weights_radius[k].value;
+			// Loop over axis_ratio weight points
+			for(int l=0; l< (int)weights_ratio.size(); l++) {
+				dp.axis_ratio = weights_ratio[l].value;
+				suf_rad = sqrt(dp.radius  * dp.radius  * dp.axis_ratio);
+				//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+				sum +=weights_length[i].weight * weights_radius[k].weight
+						* weights_ratio[l].weight *DiamCyl(dp.length,suf_rad)/2.0;
+				norm += weights_length[i].weight* weights_radius[k].weight* weights_ratio[l].weight;
+			}
+		}
+	}
+	if (norm != 0){
+		//return the averaged value
+		rad_out =  sum/norm;}
+	else{
+		//return normal value
+		//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+		rad_out = DiamCyl(dp.length,suf_rad)/2.0;}
+
+	return rad_out;
+}
Index: sansmodels/src/sans/models/c_models/flexiblecylinder.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/flexiblecylinder.cpp	(revision f10063e8f3c53d2be93abaea9c0d3d4f3061d444)
+++ sansmodels/src/sans/models/c_models/flexiblecylinder.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -42,6 +42,6 @@
 	radius  = Parameter(20.0, true);
 	radius.set_min(0.0);
-	sldCyl   = Parameter(6.3e-6);
-	sldSolv   = Parameter(1.0e-6);
+	sldCyl   = Parameter(1.0e-6);
+	sldSolv   = Parameter(6.3e-6);
 	background = Parameter(0.0001);
 }
@@ -97,10 +97,10 @@
 				sum += weights_len[i].weight
 					* weights_kuhn[j].weight*weights_rad[k].weight * FlexExclVolCyl(dp, q)
-					* pow(weights_rad[k].value,2)*weights_len[i].value;
+					* pow(weights_rad[k].value,2.0)*weights_len[i].value;
 				//Find average volume
 				vol += weights_rad[k].weight
 					* weights_len[i].weight
 					* weights_kuhn[j].weight
-					*pow(weights_rad[k].value,2)*weights_len[i].value;
+					*pow(weights_rad[k].value,2.0)*weights_len[i].value;
 				norm += weights_len[i].weight
 					* weights_kuhn[j].weight*weights_rad[k].weight;
Index: sansmodels/src/sans/models/c_models/fractal.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/fractal.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/fractal.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -0,0 +1,120 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libTwoPhase.h"
+	#include "fractal.h"
+}
+
+FractalModel :: FractalModel() {
+	scale      = Parameter(1.0);
+    radius = Parameter(5.0, true);
+    radius.set_min(0.0);
+    fractal_dim = Parameter(2.0);
+    cor_length = Parameter(100.0);
+    sldBlock = Parameter(2.0e-6);
+    sldSolv= Parameter(6.35e-6);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double FractalModel :: operator()(double q) {
+	double dp[7];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = radius();
+	dp[2] = fractal_dim();
+	dp[3] = cor_length();
+	dp[4] = sldBlock();
+	dp[5] = sldSolv();
+	dp[6] = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double vol = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		//Un-normalize Fractal by volume
+		sum += weights_rad[i].weight
+			* Fractal(dp, fabs(q)) * pow(weights_rad[i].value,3);
+		//Find average volume
+		vol += weights_rad[i].weight
+			* pow(weights_rad[i].value,3);
+
+		norm += weights_rad[i].weight;
+	}
+
+	if (vol != 0.0 && norm != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm);}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double FractalModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the FractalModel
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double FractalModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double FractalModel :: calculate_ER() {
+	//NOT implemented yet!!! 'cause None shape Model
+}
Index: sansmodels/src/sans/models/c_models/fuzzysphere.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/fuzzysphere.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/fuzzysphere.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -0,0 +1,152 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "fuzzysphere.h"
+}
+
+FuzzySphereModel :: FuzzySphereModel() {
+	scale      = Parameter(0.01);
+	radius     = Parameter(60.0, true);
+	radius.set_min(0.0);
+	fuzziness  = Parameter(10.0);
+	fuzziness.set_min(0.0);
+	sldSph   = Parameter(1.0e-6);
+	sldSolv   = Parameter(3.0e-6);
+	background = Parameter(0.001);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double FuzzySphereModel :: operator()(double q) {
+	double dp[6];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = radius();
+	dp[2] = fuzziness();
+	dp[3] = sldSph();
+	dp[4] = sldSolv();
+	dp[5] = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_radius;
+	radius.get_weights(weights_radius);
+
+	// Get the dispersion points for the fuzziness
+	vector<WeightPoint> weights_fuzziness;
+	fuzziness.get_weights(weights_fuzziness);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+	double norm_vol = 0.0;
+	double vol = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_radius.size(); i++) {
+		dp[1] = weights_radius[i].value;
+		// Loop over fuzziness weight points
+		for(int j=0; j<weights_fuzziness.size(); j++) {
+			dp[2] = weights_fuzziness[j].value;
+
+			//Un-normalize SphereForm by volume
+			sum += weights_radius[i].weight * weights_fuzziness[j].weight
+				* fuzzysphere_kernel(dp, q) * pow(weights_radius[i].value,3);
+			//Find average volume : Note the fuzziness has no contribution to the volume
+			vol += weights_radius[i].weight
+				* pow(weights_radius[i].value,3);
+
+			norm += weights_radius[i].weight * weights_fuzziness[j].weight;
+			norm_vol += weights_radius[i].weight;
+		}
+	}
+
+	if (vol != 0.0 && norm_vol != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm_vol);}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double FuzzySphereModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the sphere
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double FuzzySphereModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double FuzzySphereModel :: calculate_ER() {
+	FuzzySphereParameters dp;
+	dp.scale = scale();
+	dp.radius = radius();
+	dp.fuzziness = fuzziness();
+	dp.sldSph = sldSph();
+	dp.sldSolv = sldSolv();
+	dp.background = background();
+	double rad_out = 0.0;
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Get the dispersion points for the radius
+	// No need to consider the fuzziness.
+	vector<WeightPoint> weights_radius;
+	radius.get_weights(weights_radius);
+	// Loop over radius weight points to average the radius value
+	for(int i=0; i<weights_radius.size(); i++) {
+		sum += weights_radius[i].weight
+			* weights_radius[i].value;
+		norm += weights_radius[i].weight;
+	}
+	if (norm != 0){
+		//return the averaged value
+		rad_out =  sum/norm;}
+	else{
+		//return normal value
+		rad_out = radius();}
+
+	return rad_out;
+}
Index: sansmodels/src/sans/models/c_models/models.hh
===================================================================
--- sansmodels/src/sans/models/c_models/models.hh	(revision f10063e8f3c53d2be93abaea9c0d3d4f3061d444)
+++ sansmodels/src/sans/models/c_models/models.hh	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -22,4 +22,6 @@
 	#include "lamellarPS.h"
 	#include "lamellar.h"
+	#include "fuzzysphere.h"
+	#include "polyexclvol.h"
 }
 
@@ -85,4 +87,24 @@
 	// Constructor
 	SphereModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+class FuzzySphereModel{
+public:
+	// Model parameters
+	Parameter radius;
+	Parameter scale;
+	Parameter fuzziness;
+	Parameter sldSph;
+	Parameter sldSolv;
+	Parameter background;
+
+	// Constructor
+	FuzzySphereModel();
 
 	// Operators to get I(Q)
@@ -218,4 +240,31 @@
 };
 
+class CoreFourShellModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter rad_core;
+	Parameter sld_core;
+	Parameter thick_shell1;
+	Parameter sld_shell1;
+	Parameter thick_shell2;
+	Parameter sld_shell2;
+	Parameter thick_shell3;
+	Parameter sld_shell3;
+	Parameter thick_shell4;
+	Parameter sld_shell4;
+	Parameter sld_solv;
+	Parameter background;
+
+	// Constructor
+	CoreFourShellModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
 class CoreShellCylinderModel{
 public:
@@ -320,9 +369,29 @@
 	Parameter sldSolv;
 	Parameter background;
-	Parameter axis_theta;
-	Parameter axis_phi;
 
 	// Constructor
 	FlexibleCylinderModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+class FlexCylEllipXModel{
+public:
+	// Model parameters
+	Parameter scale;
+	Parameter length;
+	Parameter kuhn_length;
+	Parameter radius;
+	Parameter axis_ratio;
+	Parameter sldCyl;
+	Parameter sldSolv;
+	Parameter background;
+
+	// Constructor
+	FlexCylEllipXModel();
 
 	// Operators to get I(Q)
@@ -583,3 +652,61 @@
 };
 
+class Poly_GaussCoil{
+public:
+	// Model parameters
+	Parameter rg;
+	Parameter scale;
+	Parameter poly_m;
+	Parameter background;
+
+	// Constructor
+	Poly_GaussCoil();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+class FractalModel{
+public:
+	// Model parameters
+	Parameter radius;
+	Parameter scale;
+	Parameter fractal_dim;
+	Parameter cor_length;
+	Parameter sldBlock;
+	Parameter sldSolv;
+	Parameter background;
+
+	// Constructor
+	FractalModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+
+/***
+class PolymerExclVolModel{
+public:
+	// Model parameters
+	Parameter rg;
+	Parameter scale;
+	Parameter m;
+	Parameter background;
+
+	// Constructor
+	PolymerExclVolModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double calculate_ER();
+	double evaluate_rphi(double q, double phi);
+};
+***/
 #endif
Index: sansmodels/src/sans/models/c_models/polygausscoil.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/polygausscoil.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_models/polygausscoil.cpp	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
@@ -0,0 +1,147 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libTwoPhase.h"
+	#include "polygausscoil.h"
+}
+
+Poly_GaussCoil :: Poly_GaussCoil() {
+	scale      = Parameter(1.0);
+	rg     = Parameter(60.0, true);
+	rg.set_min(0.0);
+	poly_m   = Parameter(2.0);
+	background = Parameter(0.001);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double Poly_GaussCoil :: operator()(double q) {
+	double dp[4];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = rg();
+	dp[2] = poly_m();
+	dp[3] = 0.0;
+
+	// Get the dispersion points for the radius
+	//vector<WeightPoint> weights_rad;
+	//rg.get_weights(weights_rad);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+
+	/**** No rg polydispersion is applied
+	double norm = 0.0;
+	double vol = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		//Un-normalize SphereForm by volume
+		sum += weights_rad[i].weight
+			* PolyGaussCoil(dp, q) * pow(weights_rad[i].value,3);
+		//Find average volume
+		vol += weights_rad[i].weight
+			* pow(weights_rad[i].value,3);
+
+		norm += weights_rad[i].weight;
+	}
+
+	if (vol != 0.0 && norm != 0.0) {
+		//Re-normalize by avg volume
+		sum = sum/(vol/norm);}
+	return sum/norm + background();
+	****/
+
+	sum = PolyGaussCoil(dp, q);
+	return sum + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double Poly_GaussCoil :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the sphere
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double Poly_GaussCoil :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to calculate effective radius
+ * @return: effective radius value
+ */
+double Poly_GaussCoil :: calculate_ER() {
+	PolyGaussCoilParameters dp;
+	dp.scale = scale();
+	dp.rg= rg();
+	dp.poly_m = poly_m();
+	dp.background = background();
+	double rad_out = 0.0;
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	rg.get_weights(weights_rad);
+	// Loop over radius weight points to average the radius value
+	for(int i=0; i<weights_rad.size(); i++) {
+		sum += weights_rad[i].weight
+			* weights_rad[i].value;
+		norm += weights_rad[i].weight;
+	}
+	if (norm != 0){
+		//return the averaged value
+		rad_out =  sum/norm;}
+	else{
+		//return normal value
+		rad_out = rg();}
+
+	return rad_out;
+}
